package cn.ibizlab.humanresource.core.humanresource.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.humanresource.core.humanresource.domain.HRArchives;
import cn.ibizlab.humanresource.core.humanresource.filter.HRArchivesSearchContext;
import cn.ibizlab.humanresource.core.humanresource.service.IHRArchivesService;

import cn.ibizlab.humanresource.util.helper.CachedBeanCopier;
import cn.ibizlab.humanresource.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.humanresource.core.humanresource.mapper.HRArchivesMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[档案信息] 服务对象接口实现
 */
@Slf4j
@Service("HRArchivesServiceImpl")
public class HRArchivesServiceImpl extends ServiceImpl<HRArchivesMapper, HRArchives> implements IHRArchivesService {

    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRArchivesBorrowService hrarchivesborrowService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRArchivesMoveService hrarchivesmoveService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHREmployeeService hremployeeService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.base.service.IHROrganizationService hrorganizationService;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(HRArchives et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getHrarchivesid()),et);
        return true;
    }

    @Override
    public void createBatch(List<HRArchives> list) {
        list.forEach(item->fillParentData(item));
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(HRArchives et) {
        fillParentData(et);
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("hrarchivesid",et.getHrarchivesid())))
            return false;
        CachedBeanCopier.copy(get(et.getHrarchivesid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<HRArchives> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public HRArchives get(String key) {
        HRArchives et = getById(key);
        if(et==null){
            et=new HRArchives();
            et.setHrarchivesid(key);
        }
        else{
        }
        return et;
    }

    @Override
    public HRArchives getDraft(HRArchives et) {
        fillParentData(et);
        return et;
    }

    @Override
    public boolean checkKey(HRArchives et) {
        return (!ObjectUtils.isEmpty(et.getHrarchivesid()))&&(!Objects.isNull(this.getById(et.getHrarchivesid())));
    }
    @Override
    @Transactional
    public boolean save(HRArchives et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(HRArchives et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public boolean saveBatch(Collection<HRArchives> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    public void saveBatch(List<HRArchives> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }


	@Override
    public List<HRArchives> selectByHremployeeid(String employeeid) {
        return baseMapper.selectByHremployeeid(employeeid);
    }

    @Override
    public void removeByHremployeeid(String employeeid) {
        this.remove(new QueryWrapper<HRArchives>().eq("hremployeeid",employeeid));
    }

	@Override
    public List<HRArchives> selectByHrorganizationid(String organizationid) {
        return baseMapper.selectByHrorganizationid(organizationid);
    }

    @Override
    public void removeByHrorganizationid(String organizationid) {
        this.remove(new QueryWrapper<HRArchives>().eq("hrorganizationid",organizationid));
    }


    /**
     * 查询集合 有效档案
     */
    @Override
    public Page<HRArchives> searchActive(HRArchivesSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HRArchives> pages=baseMapper.searchActive(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HRArchives>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<HRArchives> searchDefault(HRArchivesSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HRArchives> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HRArchives>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 员工不在档
     */
    @Override
    public Page<HRArchives> searchNonArchives(HRArchivesSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HRArchives> pages=baseMapper.searchNonArchives(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HRArchives>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 非员工在档
     */
    @Override
    public Page<HRArchives> searchNonEmployee(HRArchivesSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HRArchives> pages=baseMapper.searchNonEmployee(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HRArchives>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(HRArchives et){
        //实体关系[DER1N_HRARCHIVES_HREMPLOYEE_HREMPLOYEEID_327A4D]
        if(!ObjectUtils.isEmpty(et.getHremployeeid())){
            cn.ibizlab.humanresource.core.humanresource.domain.HREmployee hremployee=et.getHremployee();
            if(ObjectUtils.isEmpty(hremployee)){
                cn.ibizlab.humanresource.core.humanresource.domain.HREmployee majorEntity=hremployeeService.get(et.getHremployeeid());
                et.setHremployee(majorEntity);
                hremployee=majorEntity;
            }
            et.setHremployeename(hremployee.getEmployeename());
            et.setEmployeecode(hremployee.getEmployeecode());
            et.setOrganizationname(hremployee.getOrganizationname());
            et.setOrganizationid(hremployee.getOrganizationid());
            et.setEmpstate(hremployee.getEmpstate());
        }
        //实体关系[DER1N_HRARCHIVES_HRORGANIZATION_HRORGANIZATIONID_6BD9DC]
        if(!ObjectUtils.isEmpty(et.getHrorganizationid())){
            cn.ibizlab.humanresource.core.base.domain.HROrganization hrorganization=et.getHrorganization();
            if(ObjectUtils.isEmpty(hrorganization)){
                cn.ibizlab.humanresource.core.base.domain.HROrganization majorEntity=hrorganizationService.get(et.getHrorganizationid());
                et.setHrorganization(majorEntity);
                hrorganization=majorEntity;
            }
            et.setHrorganizationname(hrorganization.getOrganizationname());
        }
    }




    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<HRArchives> getHrarchivesByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<HRArchives> getHrarchivesByEntities(List<HRArchives> entities) {
        List ids =new ArrayList();
        for(HRArchives entity : entities){
            Serializable id=entity.getHrarchivesid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }

}



